      subroutine CSR123 (CSTR,K1,K2,K3)

c Parse next field in character string CSTR for CSRC, CSRI, and CSRF.
c Fields are separated by one comma or one-or-more blanks.
c Starting at last separator (K3 @call), find
c  start of field (K1), end of field (K2), and next separator (K3 @return).
c If field is empty return with K1=K3.
c Separators between quotes (") are ignored; separator must follow 2nd quote.
c Written by C. Mueller, USGS.

      character CSTR*(*),C1*1

      LCSTR = Len(CSTR)
      K = K3
1     K = K+1
      if (K.gt.LCSTR.or.CSTR(K:K).eq.',') goto 3
      if (CSTR(K:K).eq.' ') goto 1
      K1 = K
      if (CSTR(K:K).eq.'"') then
        if (K.eq.LCSTR) goto 3
        K1 = K+1
        K = K1+Index(CSTR(K1+1:LCSTR),'"')
        if (K.eq.K1) K = LCSTR+1
      endif
      KBLANK = K+Index(CSTR(K+1:LCSTR),' ')
      if (KBLANK.eq.K) KBLANK = LCSTR+1
      KCOMMA = K+Index(CSTR(K+1:LCSTR),',')
      if (KCOMMA.eq.K) KCOMMA = LCSTR+1
      K3 = Min(KBLANK,KCOMMA)-1
      K2 = K3
      if (CSTR(K1-1:K1-1).eq.'"') K2 = K-1
2     K3 = K3+1
      if (K3.gt.LCSTR.or.CSTR(K3:K3).eq.',') return
      if (CSTR(K3:K3).eq.' ') goto 2
      K3 = K3-1
      return
3     K3 = K
      K1 = K3
      return

      end
