!-------------------------downsample------------------------------
      subroutine downsample(x,npts_old,npts_new,sps_old,sps_new)
!! purpose: downsampling x, eg. from 256-sps to 80-sps
!! Date: 06/29/06.  Written by Guoquan Wang wrote
!                   based on suggestions from David M. Boore
      real x(*)
      real time_old(500000),time_new(500000),y(500000)

      dt_old=1.0/sps_old
      dt_new=1.0/sps_new

! dt_old<dt_new

      print *, 
     :  ' Inside downsample: npts_old, npts_new, sps_old, sps_new = ',
     :                       npts_old, npts_new, sps_old, sps_new

      print *, 
     :  ' Inside downsample: dt_old, dt_new = ',
     :                       dt_old, dt_new

      do i=1,npts_old
         time_old(i)=float(i-1)*dt_old
         time_new(i)=float(i-1)*dt_new
      end do

      total_sec=npts_old*dt_old
      npts_new=int(total_sec*sps_new)-1
      
      print *,' Inside downsample: total_sec, npts_new = ', 
     :                             total_sec, npts_new

      y(:)=0.0

      i=0
 100  continue
         i=i+1
       print *, ' Inside downsample, i = ', i
       if(i.gt.npts_new) then
         go to 200
       else
         do j=1,npts_old
           if(time_new(i).ge.time_old(j).and.
     :        time_new(i).lt.time_old(j+1)) then
             slope=
     :         (time_new(i)-time_old(j))/(time_old(j+1)-time_old(j))
             y(i)=x(j)+slope*(x(j+1)-x(j))
             go to 100
           end if
         end do
       end if
 200  continue
 
      print *, ' Inside downsample, just before input y to x:'
! input y to x
       do i=1, npts_old
        x(i)=0.0
       end do
       do i=1,npts_new
        x(i)=y(i)
       end do

       return

       end
!--------------------end downsample------------------------------------
