* ------------------------------ BEGIN FBCTPR --------------------------
      subroutine FBCTPR (IFRONT,IBACK,Z,NZ)

c  Apply IFRONT% and IBACK% cosine tapers to ends of time series array Z.
c  Written by Chuck Mueller, USGS.
c  Modified by D. M. Boore on 8/31/88 to eliminate the use of ZNULL;
c  see FBCTPR_CSM for the original version.

*  Dates:  2/13/90 - if ifront or iback is zero, do not apply a taper.

      real Z(*)

      PI = 4.0*ATAN(1.0)
      LZ = NZ*(IFRONT/100.)

      if (lz .lt. 1) lz = 1

      SF = PI/LZ
      do 1 I=1,LZ
c         if (Z(I).eq.ZNULL) goto 1
         F = 0.5*(1.0-COS(SF*(I-1)))
         Z(I) = Z(I)*F
1        continue
      LZ = NZ*(IBACK/100.)

      if (lz .lt. 1) lz = 1


      SF = PI/LZ
      do 2 I=NZ,NZ-LZ+1,-1
c         if (Z(I).eq.ZNULL) goto 2
         F = 0.5*(1.0-COS(SF*(NZ-I)))
         Z(I) = Z(I)*F
2        continue

      return
      end
* ------------------------------ END FBCTPR --------------------------
