
! ------------------ BEGIN get_extrema --------------------------
      subroutine get_extrema(a, npts, 
     :   extremum, index_extremum, ndimen_extremum, nextrema)
      
! Dates: 04/05/10 - Written by D M. Boore

      real a(npts), extremum(ndimen_extremum)
      integer index_extremum(ndimen_extremum)
      
      nextrema = 0
      
      do i = 2, npts-1
        if ( (a(i) == a(i-1)) .or. 
     :        (a(i)-a(i-1))*(a(i+1)-a(i)) < 0.0) then ! equality or a sign switch, indicating an extrema
          nextrema = nextrema + 1
          extremum(nextrema) = a(i)
          index_extremum(nextrema) = i
        end if
      end do        
      
      
      return
      end
! ------------------ END get_extrema --------------------------


      